﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace vnorene_seznamy
{
    public partial class Edit : Form
    {
        public string new_data, new_name;      

        public Edit(DataValue.DataTypes data_type, DataValue value)
        {
            Dictionary<DataValue.DataTypes, Func<string, Control>> load = new Dictionary<DataValue.DataTypes, Func<string, Control>>()
            {
                { DataValue.DataTypes.Bool, bool_type },
                { DataValue.DataTypes.Byte, byte_type }, 
                { DataValue.DataTypes.Character, char_type }, 
                { DataValue.DataTypes.Integer, int_type }, 
                { DataValue.DataTypes.String, string_type }, 
                { DataValue.DataTypes.Decimal, decimal_type }, 
                { DataValue.DataTypes.Date, date_type }, 
                { DataValue.DataTypes.ZIP, zip_type }
            };

            InitializeComponent();

            this.Controls.Add(load[data_type](value.Data));
            new_data = value.Data;
            label1.Text = data_type.ToString();
            textBox1.Text = value.Name;

        }

        private void Edit_Load(object sender, EventArgs e)
        {

        }

        private Control bool_type(string data)
        {
            ComboBox combo = new ComboBox();
            combo.Location = new Point(260, 44);

            combo.Text = data;

            combo.Items.Add("True");
            combo.Items.Add("False");

            combo.TextChanged += new EventHandler((object obj, EventArgs args) =>
            {
                new_data = combo.Text;
            });

            return combo;
        }

        private Control byte_type(string data)
        {
            NumericUpDown num = new NumericUpDown();
            num.Location = new Point(260, 44);

            num.Value = byte.Parse(data);

            num.Maximum = 255;
            num.Minimum = 0;

            num.ValueChanged += new EventHandler((object obj, EventArgs args) =>
            {
                new_data = num.Value.ToString();
            });

            return num;
        }

        private Control char_type(string data)
        {
            TextBox box = new TextBox();
            box.Location = new Point(260, 44);
            box.MaxLength = 1;

            box.Text = data;

            box.TextChanged += new EventHandler((object obj, EventArgs args) =>
            {
                new_data = box.Text;
            });

            return box;
        }

        private Control int_type(string data)
        {
            NumericUpDown num = new NumericUpDown();
            num.Location = new Point(260, 44);
            num.Maximum = sizeof(int);
            num.Minimum = -sizeof(int);

            num.Value = int.Parse(data);

            num.ValueChanged += new EventHandler((object obj, EventArgs args) =>
            {
                new_data = num.Value.ToString();
            });

            return num;
        }

        private Control string_type(string data)
        {
            TextBox box = new TextBox();
            box.Location = new Point(260, 44);
            box.MaxLength = 100;

            box.Text = data;

            box.TextChanged += new EventHandler((object obj, EventArgs args) =>
            {
                new_data = box.Text;
            });

            return box;
        }

        private Control decimal_type(string data)
        {
            NumericUpDown num = new NumericUpDown();
            num.Location = new Point(260, 44);
            num.Maximum = sizeof(decimal);
            num.Minimum = -sizeof(decimal);

            num.Value = decimal.Parse(data);

            num.ValueChanged += new EventHandler((object obj, EventArgs args) =>
            {
                new_data = num.Value.ToString();
            });

            return num;
        }

        private Control date_type(string data)
        {
            string[] split = data.Split('.');
            Panel panel = new Panel();
            panel.Location = new Point(260, 44);
            panel.Size = new Size(600, 40);

            int day = int.Parse(split[0]), month = int.Parse(split[1]), year = int.Parse(split[2]);

            NumericUpDown days = new NumericUpDown();

            days.Maximum = 31;
            days.Minimum = 1;

            days.Value = int.Parse(split[0]);

            days.ValueChanged += new EventHandler((object obj, EventArgs args) =>
            {
                day = (int)days.Value;
                new_data = day.ToString() + "." + month.ToString() + "." + year.ToString();
            });

            NumericUpDown months = new NumericUpDown();
            months.Location = new Point(150, 0);

            months.Maximum = 12;
            months.Minimum = 1;

            months.Value = int.Parse(split[1]);

            months.ValueChanged += new EventHandler((object obj, EventArgs args) =>
            {
                month = (int)months.Value;
                new_data = day.ToString() + "." + month.ToString() + "." + year.ToString();
            });

            NumericUpDown years = new NumericUpDown();
            months.Location = new Point(300, 0);
            years.Maximum = 12;
            years.Minimum = 1;

            years.Value = int.Parse(split[2]);

            years.ValueChanged += new EventHandler((object obj, EventArgs args) =>
            {
                year = (int)years.Value;
                new_data = day.ToString() + "." + month.ToString() + "." + year.ToString();
            });

            panel.Controls.Add(days);
            panel.Controls.Add(months);
            panel.Controls.Add(years);

            return panel;
        }

        private Control zip_type(string data)
        {
            string[] split = data.Split(' ');
            Panel panel = new Panel();
            panel.Location = new Point(260, 44);
            panel.Size = new Size(600, 40);

            int f = int.Parse(split[0]), s = int.Parse(split[1]);

            NumericUpDown first = new NumericUpDown();

            first.Maximum = 999;
            first.Minimum = 0;

            first.Value = int.Parse(split[0]);

            first.ValueChanged += new EventHandler((object obj, EventArgs args) =>
            {
                f = (int)first.Value;
                new_data = f.ToString() + ' ' + s.ToString();
            });

            NumericUpDown second = new NumericUpDown();
            second.Location = new Point(150, 0);

            second.Maximum = 99;
            second.Minimum = 0;

            second.Value = int.Parse(split[1]);

            second.ValueChanged += new EventHandler((object obj, EventArgs args) =>
            {
                s = (int)second.Value;
                new_data = f.ToString() + ' ' + s.ToString();
            });

            panel.Controls.Add(second);
            panel.Controls.Add(first);

            return panel;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            this.DialogResult = DialogResult.OK;
        }

        private void textBox1_TextChanged(object sender, EventArgs e)
        {
            new_name = textBox1.Text;
        }
    }
}
